'use strict';

/**
 * Created by Dio on 2016/9/3.
 */
var yylibui = require('../../yylib2/index');
var YYSearchCondition = require('../search/YYSearchCondition');
var YYSearchItem = require('../search/YYSearchItem');
var YYSchemeGroup = require('../search/YYSchemeGroup');
var YYStepsNav = require('../stepsnav/YYStepsNav');
var YYStepsNavItem = require('../stepsnav/YYStepsItem');
var YYEditor = require('yylib-ui/editor/YYEditor');
var YYModalPreview = require('yylib-ui/modal/YYModalPreview');
var widgets = require('../widgets/index');
var YYPrintButton = require('../print/PrintButton');
var YYEnumSelect = require('../enum/YYEnumSelect');
var YYImageWall = require('../attach/YYImageWall');
var YYMapInput = require('../map/YYMapInput');
var YYFilterArea = require('../searchfilter/YYFilterArea');
var NccAttachMgrWidget = require('../nccattach/mgr/NccAttachMgrWidget');
var NccPrintButton = require('../print/NccPrintButton');

//建立模板uitype对应的组件解析器
var DefaultParser = {};

//初始化yylib-ui提供的组件解析器
for (var key in yylibui) {
    var comp = yylibui[key];
    DefaultParser[key] = comp;
}
//初始化widgets的组件解析器
for (var key in widgets) {
    var comp = widgets[key];
    DefaultParser[key] = comp;
}

DefaultParser.YYSearchCondition = YYSearchCondition;
DefaultParser.YYSearchItem = YYSearchItem;
DefaultParser.YYSchemeGroup = YYSchemeGroup;
DefaultParser.YYStepsNav = YYStepsNav;
DefaultParser.YYStepsNavItem = YYStepsNavItem;
DefaultParser.YYEditor = YYEditor;
DefaultParser.YYEnumSelect = YYEnumSelect;
DefaultParser.YYImageWall = YYImageWall;
DefaultParser.YYPrintButton = YYPrintButton;
DefaultParser.YYMapInput = YYMapInput;
DefaultParser.YYModalPreview = YYModalPreview;
DefaultParser.YYFilterArea = YYFilterArea;
DefaultParser.NccAttachMgrWidget = NccAttachMgrWidget;
DefaultParser.NccPrintButton = NccPrintButton;

//初始化建造页面模板的解析器
var compact = require('../templates/compact/index');

for (var key in compact) {
    var comp = compact[key];
    DefaultParser[key] = comp;
}

//初始化公有云页面模板的解析器
var ijzParser = require('../templates/ijz/index');

for (var ijzKey in ijzParser) {
    var ijzComp = ijzParser[ijzKey];
    DefaultParser[ijzKey] = ijzComp;
}

module.exports = DefaultParser;