'use strict';

var React = require('react');
var _ = require('lodash');
var ApiEditTable = {
    /**
     * 编辑表格增行
     * @param page
     * @param tableKey 编辑表格键值(卡片页面有多个编辑表格时需要传此参数)
     */
    addRow: function addRow(page, tableKey) {
        var table;
        if (tableKey) {
            table = page.findUI(tableKey);
        } else {
            var editTables = page.findUIByType("EditTableWidget");
            if (editTables && editTables.length > 0) {
                table = editTables[0];
            }
        }
        if (table && table.api) {
            table.api.addRowLast();
        }
    },
    /**
     * 编辑表格删行
     * @param page
     * @param tableKey 编辑表格键值(卡片页面有多个编辑表格时需要传此参数)
     */
    delRow: function delRow(page, tableKey) {
        var table;
        if (tableKey) {
            table = page.findUI(tableKey);
        } else {
            var editTables = page.findUIByType("EditTableWidget");
            if (editTables && editTables.length > 0) {
                table = editTables[0];
            }
        }
        if (table && table.api) {
            var rowKeys = table.api.getSelectedRowKeys();
            table.api.delRow(rowKeys);
        }
    }
};
module.exports = ApiEditTable;