'use strict';

var React = require('react');

var _require = require('yylib-ui'),
    YYClass = _require.YYClass,
    YYPage = _require.YYPage,
    YYToolbar = _require.YYToolbar,
    YYRow = _require.YYRow,
    YYCol = _require.YYCol;

var _ = require('lodash');

var CPCardHeader = YYClass.create({
    render: function render() {
        var leftButtons = [];
        var rightButtons = [];
        if (_.isArray(this.props.children)) {
            _.forEach(this.props.children, function (item, index) {
                if (React.isValidElement(item)) {
                    if (item.props.align == 'right') {
                        rightButtons.push(item);
                    } else {
                        //默认居左
                        leftButtons.push(item);
                    }
                }
            });
        }
        return React.createElement(
            YYToolbar,
            { className: 'cp2-header', enableAffix: true },
            React.createElement(
                YYRow,
                null,
                React.createElement(
                    YYCol,
                    { span: 16, style: { display: 'flex', alignItems: 'center' } },
                    leftButtons
                ),
                React.createElement(
                    YYCol,
                    { span: 8, style: { paddingRight: 20, display: 'flex', flexDirection: 'row-reverse' } },
                    rightButtons
                )
            )
        );
    }
});
module.exports = CPCardHeader;