'use strict';

/**
 * 计算器显示结果组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
//定义META
var uiMeta = {
    name: 'calcresult',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('exp', null, PropTypes.string, false, '保存用户输入信息')]
};
var replacement = [{
    reg: /\*/g,
    dest: '×'
}, {
    reg: /\//g,
    dest: '÷'
}];
var YYCalcResult = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var exp = this.props.exp;
        return React.createElement(
            'div',
            { className: this.className() },
            React.createElement(
                'div',
                { className: 'last-row' },
                exp.formula
            ),
            React.createElement(
                'div',
                { className: 'cur-row' },
                exp.result
            )
        );
    }
});
module.exports = YYCalcResult;