'use strict';

var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Progress = _require.Progress;
//定义META


var uiMeta = {
    name: 'progress',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('type', 'line', PropTypes.oneOf(['line', 'circle']), false, '进度条类型'), field('percent', 0, PropTypes.number, false, '百分比'), field('format', function (percent) {
        return percent + '%';
    }, PropTypes.func, false, '内容的模板函数,percent => percent + ' % ''), field('status', null, PropTypes.oneOf(['success', 'exception', 'active']), false, '状态'), field('showInfo', true, PropTypes.bool, false, '是否显示进度数值或状态图标'), field('strokeWidth', 10, PropTypes.number, false, '(type=line)	进度条线的宽度'), field('strokeWidth', 6, PropTypes.number, false, '(type=circle)圆形进度条线的宽度，单位是进度条画布宽度的百分比'), field('width', 132, PropTypes.number, false, '圆形进度条画布宽度')]
};
var YYProgress = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var cls = this.className();
        return React.createElement(
            'div',
            { className: cls },
            React.createElement(
                Progress,
                this.props,
                this.props.children
            )
        );
    }
});
module.exports = YYProgress;